from TransformsAI.Animo.Learning.Sensors.Primitives import VectorSensor
from TransformsAI.Animo.Learning.Sensors import SensorConfig, SensorSpec
from System import Array_1, Span_1
from TransformsAI.Animo.Objects import Character
from TransformsAI.Animo.Grid import GridObject

class CharacterSensor(VectorSensor):
    def __init__(self, sensorConfig: SensorConfig) -> None: ...
    sensorConfig : SensorConfig
    @property
    def Length(self) -> int: ...
    @property
    def OptionKeys(self) -> Array_1[str]: ...
    @property
    def SensorSpec(self) -> SensorSpec: ...
    def GetObservations(self, character: Character, values: Span_1[float]) -> None: ...


class FlattenedGridSensor(VectorSensor):
    def __init__(self, sensorConfig: SensorConfig) -> None: ...
    sensorConfig : SensorConfig
    @property
    def Length(self) -> int: ...
    @property
    def OptionKeys(self) -> Array_1[str]: ...
    @property
    def SensorSpec(self) -> SensorSpec: ...
    def GetObservations(self, character: Character, values: Span_1[float]) -> None: ...


class ObjectPropertiesSensor(VectorSensor):
    def __init__(self, sensorConfig: SensorConfig) -> None: ...
    sensedGridObject : GridObject
    sensorConfig : SensorConfig
    @property
    def Length(self) -> int: ...
    @property
    def OptionKeys(self) -> Array_1[str]: ...
    @property
    def SensorSpec(self) -> SensorSpec: ...
    def GetObservations(self, character: Character, values: Span_1[float]) -> None: ...


class ObjectTypeSensor(VectorSensor):
    def __init__(self, sensorConfig: SensorConfig) -> None: ...
    sensedObject : GridObject
    sensorConfig : SensorConfig
    @property
    def Length(self) -> int: ...
    @property
    def OptionKeys(self) -> Array_1[str]: ...
    @property
    def SensorSpec(self) -> SensorSpec: ...
    def GetObservations(self, character: Character, values: Span_1[float]) -> None: ...


class SelfAndHeldPropertiesSensor(VectorSensor):
    def __init__(self, sensorConfig: SensorConfig) -> None: ...
    sensorConfig : SensorConfig
    @property
    def Length(self) -> int: ...
    @property
    def OptionKeys(self) -> Array_1[str]: ...
    @property
    def SensorSpec(self) -> SensorSpec: ...
    def GetObservations(self, character: Character, values: Span_1[float]) -> None: ...


class SelfAndHeldTypeSensor(VectorSensor):
    def __init__(self, sensorConfig: SensorConfig) -> None: ...
    characterSensor : CharacterSensor
    heldObjectTypeSensor : ObjectTypeSensor
    sensorConfig : SensorConfig
    @property
    def Length(self) -> int: ...
    @property
    def OptionKeys(self) -> Array_1[str]: ...
    @property
    def SensorSpec(self) -> SensorSpec: ...
    def GetObservations(self, character: Character, values: Span_1[float]) -> None: ...


class SurroundingsSensor(VectorSensor):
    def __init__(self, sensorConfig: SensorConfig) -> None: ...
    sensorConfig : SensorConfig
    @property
    def Length(self) -> int: ...
    @property
    def OptionKeys(self) -> Array_1[str]: ...
    @property
    def SensorSpec(self) -> SensorSpec: ...
    def GetObservations(self, character: Character, values: Span_1[float]) -> None: ...

